VTK: vtkSortDataArray Class Reference

| VTK 9.3.1

Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | List of all members
vtkSortDataArray Class Reference

provides several methods for sorting VTK arrays. More...

`#include <vtkSortDataArray.h>`

Inheritance diagram for vtkSortDataArray:
[legend]
Collaboration diagram for vtkSortDataArray:
[legend]

## Static Public Member Functions
static void | Sort (vtkIdList *keys)
| Sorts the given array in ascending order. More...
static void | Sort (vtkAbstractArray *keys)
static void | Sort (vtkAbstractArray *keys, vtkAbstractArray *values)
| Sorts the given key/value pairs based on the keys (the keys are expected to be 1-tuples, values may have number of components >= 1). More...
static void | Sort (vtkAbstractArray *keys, vtkIdList *values)
static void | SortArrayByComponent (vtkAbstractArray *arr, int k)
| Sorts the given data array using the specified component as a key. More...
static void | SortArrayByComponent (vtkAbstractArray *arr, int k, int dir)
| Sorts the given data array using the specified component as a key. More...
static void | Sort (vtkIdList *keys, int dir)
| Sorts the given array in either ascending (dir=0) or descending (dir!=0) order. More...
static void | Sort (vtkAbstractArray *keys, int dir)
| Sorts the given array in either ascending (dir=0) or descending (dir!=0) order. More...
static void | Sort (vtkAbstractArray *keys, vtkAbstractArray *values, int dir)
| Sorts the given key/value pairs based on the keys (the keys are expected to be 1-tuples, values may have number of components >= 1). More...
static void | Sort (vtkAbstractArray *keys, vtkIdList *values, int dir)
| Sorts the given key/value pairs based on the keys (the keys are expected to be 1-tuples, values may have number of components >= 1). More...
static vtkIdType * | InitializeSortIndices (vtkIdType numKeys)
| The following are general functions which can be used to produce an ordering, and/or sort various types of VTK arrays. More...
static void | GenerateSortIndices (int dataType, void *dataIn, vtkIdType numKeys, int numComp, int k, vtkIdType *idx)
| The following are general functions which can be used to produce an ordering, and/or sort various types of VTK arrays. More...
static void | ShuffleArray (vtkIdType *idx, int dataType, vtkIdType numKeys, int numComp, vtkAbstractArray *arr, void *dataIn, int dir)
| The following are general functions which can be used to produce an ordering, and/or sort various types of VTK arrays. More...
static void | ShuffleIdList (vtkIdType *idx, vtkIdType sze, vtkIdList *arrayIn, vtkIdType *dataIn, int dir)
| The following are general functions which can be used to produce an ordering, and/or sort various types of VTK arrays. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkSortDataArray ()
| ~vtkSortDataArray () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Static Protected Member Functions
static void | GenerateSort1Indices (int dataType, void *dataIn, vtkIdType numKeys, vtkIdType *idx)
static void | Shuffle1Array (vtkIdType *idx, int dataType, vtkIdType numKeys, vtkAbstractArray *arr, void *dataIn, int dir)
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
typedef vtkObject | Superclass
| Standard VTK methods for instantiating, managing type, and printing information about this class. More...
static vtkSortDataArray * | New ()
| Standard VTK methods for instantiating, managing type, and printing information about this class. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard VTK methods for instantiating, managing type, and printing information about this class. More...
static vtkSortDataArray * | SafeDownCast (vtkObjectBase *o)
| Standard VTK methods for instantiating, managing type, and printing information about this class. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard VTK methods for instantiating, managing type, and printing information about this class. More...
vtkSortDataArray * | NewInstance () const
| Standard VTK methods for instantiating, managing type, and printing information about this class. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard VTK methods for instantiating, managing type, and printing information about this class. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard VTK methods for instantiating, managing type, and printing information about this class. More...

## Additional Inherited Members
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

provides several methods for sorting VTK arrays.

vtkSortDataArray is used to sort data, based on its value, or with an associated key, into either ascending or descending order. This is useful for operations like selection, or analysis, when evaluating and processing data. A variety of sorting functions are provided, treating both arrays (i.e., vtkAbstractArray) and id lists (vtkIdList). Note that complex arrays like variants and string arrays are also handled.

Additional functionality is provided to generate data ordering, without necessarily shuffling the data into a final, sorted position. Hence, the sorting process is organized into three steps because of the complexity of dealing with multiple types and multiple component data arrays. The first step involves creating and initializing a sorted index array, and then (second step) sorting this array to produce a map indicating the sorting order. In other words, the sorting index array is a permutation which can be applied to other, associated data to shuffle it (third step) into an order consistent with the sorting operation. Note that the generation of the sorted index array is useful unto itself (even without the final shuffling of data) because it generates an ordered list (from the data values of any component in any array). So for example, it is possible to find the top N cells with the largest scalar value simply by generating the sorting index array from the call scalar values.

Warning
  This class has been threaded with vtkSMPTools. Using TBB or other non-sequential type (set in the CMake variable VTK_SMP_IMPLEMENTATION_TYPE) may improve performance significantly on multi-core machines.
  The sort methods below are static, hence the sorting methods can be used without instantiating the class. All methods are thread safe.

See also
  vtkSortFieldData

Online Examples:

Tests:
  vtkSortDataArray (Tests)

Definition at line 68 of file vtkSortDataArray.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkSortDataArray::Superclass

Standard VTK methods for instantiating, managing type, and printing information about this class.

Definition at line 77 of file vtkSortDataArray.h.

## Constructor & Destructor Documentation

## ◆ vtkSortDataArray()

vtkSortDataArray::vtkSortDataArray | ( |  | ) |
| protected

## ◆ ~vtkSortDataArray()

vtkSortDataArray::~vtkSortDataArray | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkSortDataArray* vtkSortDataArray::New | ( |  | ) |
| static

Standard VTK methods for instantiating, managing type, and printing information about this class.

## ◆ IsTypeOf()

static vtkTypeBool vtkSortDataArray::IsTypeOf | ( | const char * | type | ) |
| static

Standard VTK methods for instantiating, managing type, and printing information about this class.

## ◆ IsA()

virtual vtkTypeBool vtkSortDataArray::IsA | ( | const char * | type | ) |
| virtual

Standard VTK methods for instantiating, managing type, and printing information about this class.

Reimplemented from vtkObjectBase.

Reimplemented in vtkSortFieldData.

## ◆ SafeDownCast()

static vtkSortDataArray* vtkSortDataArray::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard VTK methods for instantiating, managing type, and printing information about this class.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkSortDataArray::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard VTK methods for instantiating, managing type, and printing information about this class.

Reimplemented in vtkSortFieldData.

## ◆ NewInstance()

vtkSortDataArray* vtkSortDataArray::NewInstance | ( |  | ) | const

Standard VTK methods for instantiating, managing type, and printing information about this class.

## ◆ PrintSelf()

void vtkSortDataArray::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard VTK methods for instantiating, managing type, and printing information about this class.

Reimplemented from vtkObject.

Reimplemented in vtkSortFieldData.

## ◆ Sort() [1/8]

static void vtkSortDataArray::Sort | ( | vtkIdList * | keys | ) |
| inlinestatic

Sorts the given array in ascending order.

For this method, the keys must be single-component tuples.

Definition at line 85 of file vtkSortDataArray.h.

## ◆ Sort() [2/8]

static void vtkSortDataArray::Sort | ( | vtkAbstractArray * | keys | ) |
| inlinestatic

Definition at line 86 of file vtkSortDataArray.h.

## ◆ Sort() [3/8]

static void vtkSortDataArray::Sort | ( | vtkIdList * | keys,
|  | int | dir
| ) |  |
| static

Sorts the given array in either ascending (dir=0) or descending (dir!=0) order.

For this method, the keys must be single-component tuples.

## ◆ Sort() [4/8]

static void vtkSortDataArray::Sort | ( | vtkAbstractArray * | keys,
|  | int | dir
| ) |  |
| static

Sorts the given array in either ascending (dir=0) or descending (dir!=0) order.

For this method, the keys must be single-component tuples.

## ◆ Sort() [5/8]

static void vtkSortDataArray::Sort | ( | vtkAbstractArray * | keys,
|  | vtkAbstractArray * | values
| ) |  |
| inlinestatic

Sorts the given key/value pairs based on the keys (the keys are expected to be 1-tuples, values may have number of components >= 1).

Obviously, the two arrays must be of equal size. Sorts in ascending order.

Definition at line 103 of file vtkSortDataArray.h.

## ◆ Sort() [6/8]

static void vtkSortDataArray::Sort | ( | vtkAbstractArray * | keys,
|  | vtkIdList * | values
| ) |  |
| inlinestatic

Definition at line 107 of file vtkSortDataArray.h.

## ◆ Sort() [7/8]

static void vtkSortDataArray::Sort | ( | vtkAbstractArray * | keys,
|  | vtkAbstractArray * | values,
|  | int | dir
| ) |  |
| static

Sorts the given key/value pairs based on the keys (the keys are expected to be 1-tuples, values may have number of components >= 1).

Obviously, the two arrays must be of equal size. Sorts in either ascending (dir=0) or descending (dir=1) order.

## ◆ Sort() [8/8]

static void vtkSortDataArray::Sort | ( | vtkAbstractArray * | keys,
|  | vtkIdList * | values,
|  | int | dir
| ) |  |
| static

Sorts the given key/value pairs based on the keys (the keys are expected to be 1-tuples, values may have number of components >= 1).

Obviously, the two arrays must be of equal size. Sorts in either ascending (dir=0) or descending (dir=1) order.

## ◆ SortArrayByComponent() [1/2]

static void vtkSortDataArray::SortArrayByComponent | ( | vtkAbstractArray * | arr,
|  | int | k
| ) |  |
| inlinestatic

Sorts the given data array using the specified component as a key.

Think of the array as a 2-D grid with each tuple representing a row. Tuples are swapped until the k-th column of the grid is monotonically increasing. Where two tuples have the same value for the k-th component, their order in the final result is unspecified.

Definition at line 130 of file vtkSortDataArray.h.

## ◆ SortArrayByComponent() [2/2]

static void vtkSortDataArray::SortArrayByComponent | ( | vtkAbstractArray * | arr,
|  | int | k,
|  | int | dir
| ) |  |
| static

Sorts the given data array using the specified component as a key.

Think of the array as a 2-D grid with each tuple representing a row. Tuples are swapped until the k-th column of the grid is ascending (dir=0) or descending (dir=1). Where two tuples have the same value for the k-th component, their order in the final result is unspecified.

## ◆ InitializeSortIndices()

static vtkIdType* vtkSortDataArray::InitializeSortIndices | ( | vtkIdType | numKeys | ) |
| static

The following are general functions which can be used to produce an ordering, and/or sort various types of VTK arrays.

Don't use these methods unless you really know what you are doing. The basic idea is that an initial set of indices (InitializeSortIndices() that refer to the data contained in a vtkAbstractArray or vtkIdList) are sorted (GenerateSortIndices() based on the data values in the array). The result of the sort is the creation of a permutation array (the sort array idx) that indicates where the data tuples originated (e.g., after the sort, idx[0] indicates where in the array the tuple was originally located prior to sorting.) This sorted index array can be used to shuffle various types of VTK arrays (the types supported correspond to the various arrays which are subclasses of vtkDataArrayTemplate, use ShuffleArray() or for vtkIdList, use ShuffleIdList()). Also, the sort array, being an vtkIdType* (i.e., id list), can also be used to identify points or cells in sorted order (based on the data in the originating dataIn array). Note that sorting is always performed in ascending order, and the sorted index array reflects this; however the shuffling of data can be specified as either ascending (dir=0) or descending (dir=1) order. The user is responsible for taking ownership of the sort indices (i.e., free the idx array).

## ◆ GenerateSortIndices()

static void vtkSortDataArray::GenerateSortIndices | ( | int | dataType,
|  | void * | dataIn,
|  | vtkIdType | numKeys,
|  | int | numComp,
|  | int | k,
|  | vtkIdType * | idx
| ) |  |
| static

The following are general functions which can be used to produce an ordering, and/or sort various types of VTK arrays.

Don't use these methods unless you really know what you are doing. The basic idea is that an initial set of indices (InitializeSortIndices() that refer to the data contained in a vtkAbstractArray or vtkIdList) are sorted (GenerateSortIndices() based on the data values in the array). The result of the sort is the creation of a permutation array (the sort array idx) that indicates where the data tuples originated (e.g., after the sort, idx[0] indicates where in the array the tuple was originally located prior to sorting.) This sorted index array can be used to shuffle various types of VTK arrays (the types supported correspond to the various arrays which are subclasses of vtkDataArrayTemplate, use ShuffleArray() or for vtkIdList, use ShuffleIdList()). Also, the sort array, being an vtkIdType* (i.e., id list), can also be used to identify points or cells in sorted order (based on the data in the originating dataIn array). Note that sorting is always performed in ascending order, and the sorted index array reflects this; however the shuffling of data can be specified as either ascending (dir=0) or descending (dir=1) order. The user is responsible for taking ownership of the sort indices (i.e., free the idx array).

## ◆ ShuffleArray()

static void vtkSortDataArray::ShuffleArray | ( | vtkIdType * | idx,
|  | int | dataType,
|  | vtkIdType | numKeys,
|  | int | numComp,
|  | vtkAbstractArray * | arr,
|  | void * | dataIn,
|  | int | dir
| ) |  |
| static

The following are general functions which can be used to produce an ordering, and/or sort various types of VTK arrays.

Don't use these methods unless you really know what you are doing. The basic idea is that an initial set of indices (InitializeSortIndices() that refer to the data contained in a vtkAbstractArray or vtkIdList) are sorted (GenerateSortIndices() based on the data values in the array). The result of the sort is the creation of a permutation array (the sort array idx) that indicates where the data tuples originated (e.g., after the sort, idx[0] indicates where in the array the tuple was originally located prior to sorting.) This sorted index array can be used to shuffle various types of VTK arrays (the types supported correspond to the various arrays which are subclasses of vtkDataArrayTemplate, use ShuffleArray() or for vtkIdList, use ShuffleIdList()). Also, the sort array, being an vtkIdType* (i.e., id list), can also be used to identify points or cells in sorted order (based on the data in the originating dataIn array). Note that sorting is always performed in ascending order, and the sorted index array reflects this; however the shuffling of data can be specified as either ascending (dir=0) or descending (dir=1) order. The user is responsible for taking ownership of the sort indices (i.e., free the idx array).

## ◆ ShuffleIdList()

static void vtkSortDataArray::ShuffleIdList | ( | vtkIdType * | idx,
|  | vtkIdType | sze,
|  | vtkIdList * | arrayIn,
|  | vtkIdType * | dataIn,
|  | int | dir
| ) |  |
| static

The following are general functions which can be used to produce an ordering, and/or sort various types of VTK arrays.

Don't use these methods unless you really know what you are doing. The basic idea is that an initial set of indices (InitializeSortIndices() that refer to the data contained in a vtkAbstractArray or vtkIdList) are sorted (GenerateSortIndices() based on the data values in the array). The result of the sort is the creation of a permutation array (the sort array idx) that indicates where the data tuples originated (e.g., after the sort, idx[0] indicates where in the array the tuple was originally located prior to sorting.) This sorted index array can be used to shuffle various types of VTK arrays (the types supported correspond to the various arrays which are subclasses of vtkDataArrayTemplate, use ShuffleArray() or for vtkIdList, use ShuffleIdList()). Also, the sort array, being an vtkIdType* (i.e., id list), can also be used to identify points or cells in sorted order (based on the data in the originating dataIn array). Note that sorting is always performed in ascending order, and the sorted index array reflects this; however the shuffling of data can be specified as either ascending (dir=0) or descending (dir=1) order. The user is responsible for taking ownership of the sort indices (i.e., free the idx array).

## ◆ GenerateSort1Indices()

static void vtkSortDataArray::GenerateSort1Indices | ( | int | dataType,
|  | void * | dataIn,
|  | vtkIdType | numKeys,
|  | vtkIdType * | idx
| ) |  |
| staticprotected

## ◆ Shuffle1Array()

static void vtkSortDataArray::Shuffle1Array | ( | vtkIdType * | idx,
|  | int | dataType,
|  | vtkIdType | numKeys,
|  | vtkAbstractArray * | arr,
|  | void * | dataIn,
|  | int | dir
| ) |  |
| staticprotected

The documentation for this class was generated from the following file:

- Common/Core/vtkSortDataArray.h